#ifndef __TRANSFORM3_H
#define __TRANSFORM3_H

#include "glInterface.h"
#include "common.h"
#include <Cg/cg.h>
#include <Cg/cgGL.h>


namespace CHCDemoEngine 
{

class RenderState;
class Matrix4x4;


/** Class representing a transformation
*/
class Transform3
{
public:
	
	/** Creates a scene entity.
	*/
	Transform3(Matrix4x4 *trafo);

	~Transform3();
	/** Loads this transformation.
	*/
	void Load(RenderState *state);	
	/** Unloads this transformation
	*/
	void Unload(RenderState *state);
	/** Returns the trafo of this scene entity.
	*/
	inline Matrix4x4 *GetMatrix() const  { return mMatrix; }

	static CGparameter sModelMatrixParam;

protected:

	/// transform matrix 
	Matrix4x4 *mMatrix;
};


}

#endif // __TRANSFORM_H